'From Squeak3.4 of ''1 March 2003'' [latest update: #5171] on 23 August 2003 at 10:45:11 pm'!

!OGGFile methodsFor: 'initialize-release' stamp: 'rop 8/11/2003 16:06'!
closeFile
	self finalize.! !

!OGGFile methodsFor: 'initialize-release' stamp: 'rop 8/11/2003 16:06'!
openFile: aPath
	pathToFile _ aPath.
	fileBits _ self primFileOpen: aPath.
	fileBits notNil ifTrue: 
		[fileIndex _ Smalltalk registerExternalObject: fileBits.
		self register.]
	! !

!OGGFile methodsFor: 'file ops' stamp: 'rop 8/11/2003 16:06'!
finalize
	self fileHandle notNil ifTrue: [self primFileClose: self fileHandle].
	self fileHandle = fileBits ifTrue: [Smalltalk unregisterExternalObject: fileIndex].
	fileBits _ nil.	
	fileIndex _ 0.! !

!OGGFile methodsFor: 'access' stamp: 'rop 8/11/2003 16:06'!
endianness
	^endianness isNil ifTrue: [endianness _ Smalltalk endianness] ifFalse: [endianness]! !

!OGGFile methodsFor: 'access' stamp: 'rop 8/11/2003 16:06'!
fileHandle
	(Smalltalk externalObjects at: fileIndex ifAbsent: [^nil]) == fileBits 
		ifTrue: [^fileBits]
		ifFalse: [^nil].
! !

!OGGFile methodsFor: 'access' stamp: 'rop 8/11/2003 16:06'!
fileName
	^pathToFile! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/11/2003 22:02'!
audioChannels: aStream
	"Returns -1 if error, otherwise returns audioChannels for stream aStream"
	self hasAudio ifFalse: [^ 0].
	^[self primAudioChannels: self fileHandle stream: aStream] on: Error do: [-1]
! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/11/2003 16:06'!
audioGetSample: aStream
	"Returns number of current sample, or -1 if error"
	self hasAudio ifFalse: [^-1].
	^[(self primGetSample: self fileHandle stream: aStream) asInteger] on: Error do: [-1]
! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/11/2003 23:06'!
audioPlayerForChannel: channelNumber
	"Answer a streaming sound for playing the audio channel with the given index."
	"Note: The MP3 player can not yet isolate a single channel from a multi-channel audio stream."

	^ StreamingOggSound new initOggFile: self streamIndex: 0
! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/12/2003 12:24'!
audioReadBuffer: aBuffer stream: aStreamNumber
	"Returns -1 if error, otherwise 0"
	self hasAudio ifFalse: [^-1].
	^[self audioReadBuffer: aBuffer stream: aStreamNumber samples: (aBuffer size* aBuffer bytesPerElement)//2] on: Error do: [-1]! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/23/2003 15:18'!
audioReadBuffer: aBuffer stream: aStreamNumber samples: aSampleNumber
	"Returns -1 if error, otherwise 0
	Note this call requires passing in the samples to read, ensure you get the number right"

	self hasAudio ifFalse: [^-1].
	^[self primAudioReadBuffer: self fileHandle  buffer: aBuffer samples: aSampleNumber stream: aStreamNumber] on: Error do: [-1]! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/23/2003 20:51'!
audioSampleRate: aStream
	"Returns sample rate, or -1 if error"
	self hasAudio ifFalse: [^-1].
	^[self primSampleRate: self fileHandle stream: aStream] on: Error do: [-1]
! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/11/2003 16:06'!
audioSamples: aStream
	"Returns -1 if error, 
	otherwise returns audioSamples for stream aStream"
	self hasAudio ifFalse: [^-1].
	^[(self primAudioSamples: self fileHandle stream: aStream) asInteger] on: Error do: [-1]
! !

!OGGFile methodsFor: 'audio' stamp: 'rop 8/11/2003 16:06'!
audioSetSample: aNumber stream: aStream
	"Set number of targeted sample, returns 0 if ok, -1 if failure"
	self hasAudio ifFalse: [^-1].
	^[self primSetSample: self fileHandle sample: aNumber asFloat stream: aStream] on: Error do: [-1]
! !

!OGGFile methodsFor: 'private' stamp: 'rop 8/11/2003 16:06'!
register
	^self class register: self! !

!OGGFile methodsFor: 'private' stamp: 'rop 8/11/2003 16:06'!
unregister
	^self class unregister: self! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/11/2003 22:03'!
primAudioChannels: aHandle stream: aStream
	<primitive: 'primitiveOggAudioChannels' module: 'OggPlugin'>
	self primitiveFailed! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/12/2003 12:25'!
primAudioReadBuffer: aFileHandle  buffer: aBuffer samples: aSampleNumber stream: aStreamNumber
	<primitive: 'primitiveOggReadAudio' module: 'OggPlugin'>
	self primitiveFailed! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/11/2003 23:37'!
primAudioSamples: aHandle stream: aStream
	<primitive: 'primitiveOggAudioSamples' module: 'OggPlugin'>
	self primitiveFailed! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/11/2003 21:36'!
primFileClose: aHandle
	"Close the file"
	<primitive: 'primitiveOggClose' module: 'OggPlugin'>
	self primitiveFailed! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/11/2003 16:07'!
primFileOpen: aPath
	"Open the file"
	<primitive: 'primitiveOggOpen' module: 'OggPlugin'>
	self primitiveFailed! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/11/2003 23:54'!
primGetSample: aHandle stream: aStream
	<primitive: 'primitiveOggGetSample' module: 'OggPlugin'>
	self primitiveFailed! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/11/2003 22:54'!
primSampleRate: aHandle stream: aStream
	<primitive: 'primitiveOggSampleRate' module: 'OggPlugin'>
	self primitiveFailed! !

!OGGFile methodsFor: 'primitives' stamp: 'rop 8/12/2003 12:06'!
primSetSample: aHandle sample: aSampleNumber stream: aStream
	<primitive: 'primitiveOggSetSample' module: 'OggPlugin'>
	self primitiveFailed! !


!OGGFile class methodsFor: 'registry' stamp: 'rop 8/11/2003 16:06'!
register: anObject
	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry add: anObject! !

!OGGFile class methodsFor: 'registry' stamp: 'rop 8/11/2003 16:06'!
registry
	WeakArray isFinalizationSupported ifFalse:[^nil].
	^Registry isNil
		ifTrue:[Registry := WeakRegistry new]
		ifFalse:[Registry].! !

!OGGFile class methodsFor: 'registry' stamp: 'rop 8/11/2003 16:06'!
unregister: anObject
	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry remove: anObject ifAbsent:[]! !

!OGGFile class methodsFor: 'instance creation' stamp: 'rop 8/11/2003 16:06'!
openFile: aPath
	^self new initialize openFile: aPath.! !

!OGGFile class methodsFor: 'testing' stamp: 'rop 8/11/2003 23:25'!
isFileValidOGG: path
	^self primFileValidOGG: path! !

!OGGFile class methodsFor: 'primitives' stamp: 'rop 8/11/2003 23:25'!
primFileValidOGG: aPath
	"Check to see if the file is valid"
	<primitive: 'primitiveOggCheckSig' module: 'OggPlugin'>
	self primitiveFailed! !


!OggPlugin methodsFor: 'support' stamp: 'rop 8/22/2003 23:49'!
checkFileEntry: anOggFile

	self var: #anOggFile declareC: 'ogg_t * anOggFile'.
	1 to: maximumNumberOfFilesToWatch do: 
		[:i | ((oggFiles at: i) = anOggFile) ifTrue: 
				[^true]].
	^false.
! !

!OggPlugin methodsFor: 'support' stamp: 'rop 8/11/2003 15:35'!
initialiseModule
	self export: true.
	maximumNumberOfFilesToWatch _ 1024.
	1 to: maximumNumberOfFilesToWatch do: [:i | oggFiles at: i put: 0].
	^self cCode: 'true' inSmalltalk:[true]! !

!OggPlugin methodsFor: 'support' stamp: 'rop 8/22/2003 23:50'!
makeFileEntry: anOggFile
	self var: #anOggFile declareC: 'ogg_t * anOggFile'.
	1 to: maximumNumberOfFilesToWatch do: 
		[:i | ((oggFiles at: i) = 0) ifTrue: 
				[oggFiles at: i put: anOggFile.
				^true]].
	^false
	"Ok no room just ignore, we'll get a primitive failure later"
! !

!OggPlugin methodsFor: 'support' stamp: 'rop 8/22/2003 23:52'!
oggValueOf: oggtHandle
	"Return a pointer to the first byte of the OggVorbis_File record within the given Smalltalk bytes object, or nil if oop is not an file record."

	| index check |

	self returnTypeC: 'ogg_t *'.
	self var: #index declareC: 'ogg_t ** index'.
	interpreterProxy success: ((interpreterProxy isBytes: oggtHandle)
			and: [(interpreterProxy byteSizeOf: oggtHandle)
					= 4]).
	interpreterProxy failed
		ifTrue: [^ nil]
		ifFalse: 
			[index _ self cCoerce: (interpreterProxy firstIndexableField: oggtHandle)
						to: 'ogg_t **'.
			self cCode: 'check = checkFileEntry(*index)'.
			check = 0 ifTrue: [^nil]. 
			^ self cCode: '*index']! !

!OggPlugin methodsFor: 'support' stamp: 'rop 8/22/2003 23:53'!
removeFileEntry: anOggFile
	self var: #anOggFile declareC: 'ogg_t * anOggFile'.
	1 to: maximumNumberOfFilesToWatch do: 
		[:i | ((oggFiles at: i) = anOggFile) ifTrue: 
				[oggFiles at: i put: 0.
				^true]].
	"Just ignore"
	^false
		
! !

!OggPlugin methodsFor: 'support' stamp: 'rop 8/22/2003 23:53'!
shutdownModule
	self export: true.
	1 to: maximumNumberOfFilesToWatch do: 
		[:i | ((oggFiles at: i) ~= 0) ifTrue:
			[self cCode: 'ogg_close(oggFiles[i])'.
			oggFiles at: i put: 0]].
	^self cCode:  'true' inSmalltalk:[true]! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 00:35'!
primitiveOggAudioChannels: fileHandle stream: aNumber
	| file result |

	"int ogg_channels(ogg_t *file, int stream)"
	self var: #file declareC: 'ogg_t * file'.
	self primitive: 'primitiveOggAudioChannels'
		parameters: #(Oop SmallInteger).

	file _ self oggValueOf: fileHandle.
	file = nil ifTrue: [^0].
	aNumber < 0 ifTrue: [interpreterProxy success: false. ^0].
	aNumber >= (self cCode: 'ogg_streams(file)') ifTrue: [
		interpreterProxy success: false. ^0.
	].

	result := self cCode: 'ogg_channels(file,aNumber)'.
	^result asSmallIntegerObj
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 12:54'!
primitiveOggAudioSamples: fileHandle stream: aNumber
	| file result |

	"long ogg_samples(ogg_t *file, int stream)"
	self var: #file declareC: 'ogg_t * file'.
	self primitive: 'primitiveOggAudioSamples'
		parameters: #(Oop SmallInteger).

	file _ self oggValueOf: fileHandle.
	file = nil ifTrue: [^0].
	aNumber < 0 ifTrue: [interpreterProxy success: false. ^nil].
	aNumber >= (self cCode: 'ogg_streams(file)') ifTrue: [
		interpreterProxy success: false. ^0.
	].

	self cCode: 'result = ogg_samples(file,aNumber)'.
	^result asOop: Float
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 12:29'!
primitiveOggCheckSig: path
	| result sz storage |

	"int mpeg3_check_sig(char *path)"
	self var: #storage declareC: 'char storage[1024] '.
	self primitive: 'primitiveOggCheckSig'
		parameters: #(String).
	sz _ interpreterProxy byteSizeOf: path cPtrAsOop.
	self cCode: 'strncpy(storage,path,sz)'.
	storage at: sz put: 0.
	self cCode: 'result = ogg_check_sig(storage)'.
	^result asOop: Boolean
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 00:00'!
primitiveOggClose: fileHandle
	| file index |

	"int ogg_close(mpeg3_t *file)"
	self var: #file declareC: 'ogg_t * file'.
	self var: #index declareC: 'ogg_t ** index'.
	self primitive: 'primitiveOggClose'
		parameters: #(Oop).
	file _ self oggValueOf: fileHandle.
	file = nil ifTrue: [^nil].
	self cCode: 'removeFileEntry(file); ogg_close(file)'.
	index _ self cCoerce: (interpreterProxy firstIndexableField: fileHandle)
						to: 'ogg_t **'.
	self cCode: '*index = 0'.
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 12:59'!
primitiveOggGetSample: fileHandle stream: aNumber
	| file result |

	"long ogg_current_sample(ogg_t *file, int stream)"
	self var: #file declareC: 'ogg_t * file'.
	self primitive: 'primitiveOggGetSample'
		parameters: #(Oop SmallInteger).

	file _ self oggValueOf: fileHandle.
	file = nil ifTrue: [^0].
	aNumber < 0 ifTrue: [interpreterProxy success: false. ^nil].
	aNumber >= (self cCode: 'result = ogg_streams(file)') ifTrue: [
		interpreterProxy success: false.  ^0 ].


	self cCode: 'result = ogg_current_sample(file,aNumber)'.
	^result asOop: Float
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 00:11'!
primitiveOggOpen: path
	| oggOop index sz storage |

	"int ogg_open(char *path);"
	self var: #index declareC: 'ogg_t ** index'.
	self var: #storage declareC: 'char storage[1024]'.
	self primitive: 'primitiveOggOpen' parameters: #(String).
	sz _ interpreterProxy byteSizeOf: path cPtrAsOop.
	self cCode: 'strncpy(storage,path,sz)'.
	storage at: sz put: 0.
	oggOop _ interpreterProxy instantiateClass: interpreterProxy classByteArray
					indexableSize: 4.	
	index _ self cCoerce: (interpreterProxy firstIndexableField: oggOop)
						to: 'ogg_t **'.
	self cCode: '*index = ogg_open(storage); makeFileEntry(*index)'.
	^oggOop
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 12:55'!
primitiveOggReadAudio: fileHandle shortArray: anArray samples: aSampleNumber stream: aNumber
	| file result arrayBase |

	"int ogg_read_audio(ogg_t *file, 
		short *output_i, 
		long samples,
		int stream)"
	self var: #file declareC: 'ogg_t * file'.
	self var: #arrayBase declareC: 'short * arrayBase'.
	self primitive: 'primitiveOggReadAudio'
		parameters: #(Oop Array SmallInteger SmallInteger).

	file _ self oggValueOf: fileHandle.
	file = nil ifTrue: [^0].
	aNumber < 0 ifTrue: [interpreterProxy success: false. ^nil].
	aNumber >= (self cCode: 'result = ogg_streams(file)') ifTrue: [
		interpreterProxy success: false.  ^0 ].
	arrayBase _ self cCoerce: anArray to: 'short *'.
	interpreterProxy failed ifTrue: [^nil].

	self cCode: 'result = ogg_read_audio(file,arrayBase,aSampleNumber,aNumber)'.
	^result asSmallIntegerObj
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 00:54'!
primitiveOggSampleRate: fileHandle stream: aNumber
	| file result |

	"int ogg_channels(ogg_t *file, int stream)"
	self var: #file declareC: 'ogg_t * file'.
	self primitive: 'primitiveOggSampleRate'
		parameters: #(Oop SmallInteger).

	file _ self oggValueOf: fileHandle.
	file = nil ifTrue: [^0].
	aNumber < 0 ifTrue: [interpreterProxy success: false. ^0].
	aNumber >= (self cCode: 'ogg_streams(file)') ifTrue: [
		interpreterProxy success: false. ^0.
	].

	result := self cCode: 'ogg_sampleRate(file,aNumber)'.
	^result asOop: Float
! !

!OggPlugin methodsFor: 'primitives' stamp: 'rop 8/23/2003 13:04'!
primitiveOggSetSample: fileHandle sample: aSampleNumber stream: aNumber
	| file result |

	"int ogg_set_sample(ogg_t *file, long sample, int stream)"
	self var: #file declareC: 'ogg_t * file'.
	self primitive: 'primitiveOggSetSample'
		parameters: #(Oop Float SmallInteger).

	file _ self oggValueOf: fileHandle.
	file = nil ifTrue: [^0].
	aNumber < 0 ifTrue: [interpreterProxy success: false. ^nil].
	aNumber >= (self cCode: 'result = ogg_streams(file)') ifTrue: [
		interpreterProxy success: false.  ^0 ].


	aSampleNumber < 0 ifTrue: [interpreterProxy success: false. ^nil].
	self cCode: 'result = ogg_set_sample(file,(long)aSampleNumber,aNumber)'.
	^result asSmallIntegerObj
! !


!OggPlugin class methodsFor: 'initialize-release' stamp: 'rop 8/22/2003 23:48'!
declareCVarsIn: cg 
	super declareCVarsIn: cg.
	cg var: 'oggFiles' declareC: 'ogg_t *oggFiles[1024+1]'.
! !

!OggPlugin class methodsFor: 'initialize-release' stamp: 'rop 8/11/2003 15:33'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!OggPlugin class methodsFor: 'initialize-release' stamp: 'rop 8/11/2003 15:33'!
requiresCrossPlatformFiles
	"If there cross platform files to be associated with the plugin, here is where you want to flag"
	^true! !

!OggPlugin class methodsFor: 'initialize-release' stamp: 'rop 8/11/2003 15:33'!
requiresPlatformFiles
	"If there platform files to be associated with the plugin, here is where you want to flag"
	^true! !


!StreamingOggSound methodsFor: 'initialization' stamp: 'rop 8/11/2003 23:24'!
initOGGFile: anOGGFile streamIndex: anInteger
	"Initialize for playing the given stream of the given Ogg file."

	volume _ 0.3.
	repeat _ false.
	oggFile _ anOGGFile.
	oggStreamIndex _ anInteger.
	totalSamples _ oggFile audioSamples: oggStreamIndex.
	self reset.
! !

!StreamingOggSound methodsFor: 'file ops' stamp: 'rop 8/12/2003 12:17'!
closeFile
	"Close the OGG file."

	self pause.
	oggFile ifNil: [^ self].
	oggFile closeFile.
	oggFile _ nil.
	mixer _ nil.
! !

!StreamingOggSound methodsFor: 'file ops' stamp: 'rop 8/12/2003 12:16'!
oggFileIsOpen
	"Answer true if I have an open, valid MPEG file handle. If the handle is not valid, try to re-open the file."

	oggFile ifNil: [^ false].
	oggFile fileHandle ifNil: [
		"try to reopen the file, which may have been saved in a snapshot"
		oggFile openFile: oggFile fileName.
		oggFile fileHandle ifNil: [oggFile _ nil]].
	^ oggFile notNil
! !

!StreamingOggSound methodsFor: 'accessing' stamp: 'rop 8/11/2003 23:06'!
duration
	"Answer the duration of this sound in seconds."

	^ totalSamples asFloat / streamSamplingRate
! !

!StreamingOggSound methodsFor: 'accessing' stamp: 'rop 8/11/2003 23:06'!
repeat
	"Answer the repeat flag."

	repeat ifNil: [repeat _ false].
	^ repeat
! !

!StreamingOggSound methodsFor: 'accessing' stamp: 'rop 8/11/2003 23:06'!
repeat: aBoolean
	"Set the repeat flag. If true, this sound will loop back to the beginning when it gets to the end."

	repeat _ aBoolean.
! !

!StreamingOggSound methodsFor: 'accessing' stamp: 'rop 8/11/2003 23:06'!
streamSamplingRate
	"Answer the sampling rate of the MP3 stream."

	^ streamSamplingRate
! !

!StreamingOggSound methodsFor: 'accessing' stamp: 'rop 8/11/2003 23:06'!
volume
	"Answer my volume."

	^ volume
! !

!StreamingOggSound methodsFor: 'accessing' stamp: 'rop 8/11/2003 23:06'!
volume: aNumber
	"Set my volume to the given number between 0.0 and 1.0."

	volume _ aNumber.
	self createMixer.
! !

!StreamingOggSound methodsFor: 'playing' stamp: 'rop 8/12/2003 12:17'!
millisecondsSinceStart
	"Answer the number of milliseconds since this sound started playing."

	| i mSecs |
	oggFile ifNil: [^ 0].
	oggFile fileHandle ifNil: [^ 0].  "mpeg file not open"
	i _ oggFile audioGetSample: oggStreamIndex.
	i < 0 ifTrue: [^ 0].  "movie file has no audio"
	mSecs _ i * 1000 // streamSamplingRate.
	(self isPlaying and: [lastBufferMSecs > 0]) ifTrue: [
		"adjust mSecs by the milliseconds since the last buffer"
		mutex critical: [
			mSecs _ i * 1000 // streamSamplingRate.
			mSecs _ mSecs + ((Time millisecondClockValue - lastBufferMSecs) max: 0)]].
	^ mSecs + 350 - (2 * SoundPlayer bufferMSecs)
! !

!StreamingOggSound methodsFor: 'playing' stamp: 'rop 8/12/2003 12:18'!
playSampleCount: n into: aSoundBuffer startingAt: startIndex
	"Mix the next n samples of this sound into the given buffer starting at the given index"

	| current |
	self repeat ifTrue: [  "loop if necessary"
		current _ oggFile audioGetSample: oggStreamIndex.
		(totalSamples - current) < n ifTrue: [
			oggFile audioSetSample: 0 stream: oggStreamIndex]].

	mutex critical: [
		lastBufferMSecs _ Time millisecondClockValue.
		self loadBuffersForSampleCount: (n * streamSamplingRate) // SoundPlayer samplingRate.
		mixer playSampleCount: n into: aSoundBuffer startingAt: startIndex].
! !

!StreamingOggSound methodsFor: 'playing' stamp: 'rop 8/11/2003 23:36'!
reset

	super reset.
	self createMixer.
	oggFile audioSetSample: 0 stream: oggStreamIndex.
	lastBufferMSecs _ 0.
	mutex _ Semaphore forMutualExclusion.
! !

!StreamingOggSound methodsFor: 'playing' stamp: 'rop 8/12/2003 12:19'!
samplesRemaining

	| samplesPlayed |
	oggFile ifNil: [^ 0].
	self repeat ifTrue: [^ 1000000].
	samplesPlayed _ oggFile audioGetSample: oggStreamIndex.
	samplesPlayed > totalSamples ifTrue: [^ 0].
	^ totalSamples - samplesPlayed
! !

!StreamingOggSound methodsFor: 'private' stamp: 'rop 8/23/2003 20:52'!
createMixer
	"Create a mixed sound consisting of sampled sounds with one sound buffer's worth of samples. The sound has the same sampling rate and number of channels as the MPEG or MP3 file."

	| channels pan snd |
	oggFile ifNil: [^ self error: 'No Ogg file'].
	channels _ oggFile audioChannels: oggStreamIndex.
	streamSamplingRate _ oggFile audioSampleRate: oggStreamIndex.
	mixer _ MixedSound new.
	1 to: channels do: [:c |
		channels = 1
			ifTrue: [pan _ 0.5]
			ifFalse: [pan _ (c - 1) asFloat / (channels - 1)].
		snd _ SampledSound
			samples: (SoundBuffer newMonoSampleCount: 2)  "buffer size will be adjusted dynamically"
			samplingRate: streamSamplingRate.
		mixer add: snd pan: pan volume: volume].
! !

!StreamingOggSound methodsFor: 'private' stamp: 'rop 8/23/2003 20:57'!
loadBuffersForSampleCount: count
	"Load the sound buffers for all tracks with the next count samples from the Ogg file sound track."

	| snd buf arr |
	buf _ SoundBuffer newStereoSampleCount: count.
	oggFile
		audioReadBuffer: buf
		stream: oggStreamIndex.

	arr := buf splitStereo.

	1 to: mixer sounds size do: [ :i |
		snd := mixer sounds at: i.
		snd setSamples: (arr at: i) samplingRate: streamSamplingRate.
	].

	mixer reset.
! !


!StreamingOggSound class methodsFor: 'instance creation' stamp: 'rop 8/11/2003 23:50'!
onFileNamed: fileName
	"Answer an instance of me for playing the sound track of the MPEG or MP3 file with the given name. Answer nil the file is not a valid MPEG or MP3 file."

	| oggFile |
	(OGGFile isFileValidOGG: fileName) ifFalse: [^ nil].
	oggFile _ OGGFile openFile: fileName.
	^ self new initOGGFile: oggFile streamIndex: 0  "assume sound track is in stream 0"
! !

